Lua_BeastLineupItem = class("Lua_BeastLineupItem", Lua_DisplayObject)
function Lua_BeastLineupItem:ctor(p)
	self:superCall("ctor", p, "BeastLineupItem_skin")
end

function Lua_BeastLineupItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg.clickScale = false;

	self:hideDisplay();
end

function Lua_BeastLineupItem:dispose()
	if self.redPoint then
		self.redPoint:dispose()
		self.redPoint = nil
	end
	self.owner = nil
	self.callBack = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_BeastLineupItem:setData(lineupIdx, pos, beastArr, beastTeamDic)
	self.bUnlcok, self.unOpenStr = DataCenter.strangeBeastData:checkLineupState(1, pos);
	if self.bUnlcok ~= true then
		self.bg:setAltas("common_altas_5", "xui_ys_itembg_0");
		self.icon:setEnable(false);
		self.addSp:setEnable(false);
		self.lockSp:setEnable(true);
		self:showRedDot(false);
	else
		local beastId = beastArr[pos];
		if beastId ~= nil and beastId > 0 then
			local beastVo = DataCenter.strangeBeastData:getStrangeBeastVoById(beastId);
			if beastVo ~= nil then
				self.bg:setAltas(beastVo.embattle_bg_atlas, beastVo.embattle_bg_sprite);
				self.icon:setAltas(beastVo.embattle_atlas, beastVo.embattle_sprite);
				self.icon:setEnable(true);
			end
			self.addSp:setEnable(false);
			self.lockSp:setEnable(false);
			self:showRedDot(false);
		else
			self.bg:setAltas("common_altas_5", "xui_ys_itembg_0")
			self.icon:setEnable(false);
			self.addSp:setEnable(true);
			self.lockSp:setEnable(false);

			local beastId = DataCenter.heroLineupData:getUnWearBeast(beastTeamDic, lineupIdx)
			self:showRedDot(beastId ~= nil);
		end
	end
end

function Lua_BeastLineupItem:showRedDot(value)
	if value == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content)
			self.redPoint:setLocation(24, 23, 0)
			self.redPoint:createRedPointEff()
		end
		self.redPoint:updateRedPointShow(true)
	else
		if self.redPoint then
			self.redPoint:updateRedPointShow(false)
		end
	end
end

function Lua_BeastLineupItem:setClick(owner, callBack)
	self.owner = owner
	self.callBack = callBack
	if owner == nil or callBack == nil then
		self.bg:removeClickFuntion(self, self.onClick)
	else
		self.bg:addClickFuntion(self, self.onClick)
	end
end

function Lua_BeastLineupItem:onClick(go)
	if self.bUnlcok ~= true then
		OperateAlert.show(self.unOpenStr);
		return;
	end
	if self.owner and self.callBack then
		self.callBack(self.owner)
	end
end

function Lua_BeastLineupItem:hideDisplay()
	self.icon:setEnable(false);
	self.addSp:setEnable(false);
	self.lockSp:setEnable(false);
end