--战斗布阵
checkRequire("Lua_BaseLineupWindow");
-- checkRequire("Lua_FightLineupConnectItem");
checkRequire("Lua_HeroLineupAureoleItem");
Lua_FightLineupWindow = class("Lua_FightLineupWindow", Lua_BaseLineupWindow)
function Lua_FightLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_FightLineupWindow";
    self.skinName = "FightLineupWindow_skin";
end

function Lua_FightLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.btnFight:addClickFuntion(self, self.onBtnFightClick);
    self.one_btn:setEnable(DataCenter.funcOpenData:isOpened(10266));
    self.one_btn:addClickFuntion(self, self.onOneBtnClick);

    self.attackerItem = Lua_HeroLineupAureoleItem.new(self.topObject)
    self.attackerItem:setLocation(-312, -41, 0)

    self.defenderItem = Lua_HeroLineupAureoleItem.new(self.topObject, 2)
    self.defenderItem:setLocation(312, -41, 0)
end

function Lua_FightLineupWindow:dispose()
    if self.attackerItem then
        self.attackerItem:dispose();
        self.attackerItem = nil;
    end
    if self.defenderItem then
        self.defenderItem:dispose();
        self.defenderItem = nil;
    end
    if self.enemyLineupPanel ~= nil then
        self.enemyLineupPanel:dispose();
        self.enemyLineupPanel = nil;
    end
    self.enemyMsg = nil;
    self:superCall("dispose");
end

function Lua_FightLineupWindow:onBackBtnClick(go)
    if self.onFightTime ~= nil and getTime() - self.onFightTime <= 1 then
        return;
    end
    if self:onBackClickCheck() then
        self:superCall("onBackBtnClick", go);
    end
end

function Lua_FightLineupWindow:updateShowInfo(param)
    if type(param) == "table" then
        self.template_id = param.templateId;
        self.monster_player_id = param.monsterPlayerId;
        self.stage_id = param.stageId;
        if param.defaultCamp ~= nil then
            self.defaultCamp = param.defaultCamp;
        end
        self.lineupType = param.lineupType;
    elseif type(param) == "number" then
        self.template_id = param;
    end
    if self.lineupType == nil then
        self.lineupType = Lua_FightTemplateConfigData.getConfigData(self.template_id).lineup_type;
    end

    self:showSceneByTemplateId(self.template_id);
    self:updateLineupInfo();
    self:updateEnemyInfo();
    self:createTeamButton(param.teamNum);
    self.campSiftPanel:setSelected(self.defaultCamp, 0);
end

-- 己方光环更新
function Lua_FightLineupWindow:updateAureoleInfo()
    local force = DataCenter.heroLineupData:calcLineupForce(self.lineupType, self.lineupIdx);
    self.attackerItem:setName(DataCenter.roleData.name);
    self.attackerItem:setForce(force);
    self.attackerItem:setLineup(self.lineupType, self.lineupIdx);
end

-- 更新敌方数据
function Lua_FightLineupWindow:updateEnemyInfo()
    if self.monster_player_id then
        local config = Lua_MonsterPlayerConfigData.getConfigData(self.monster_player_id);
        self.defenderItem:setName(config.name[self.lineupIdx]);
        self.defenderItem:setForce(config.force[self.lineupIdx]);
        self:updateEnemyLineup(1, config.fighter_list);
    elseif self.enemyMsg then
        self.defenderItem:setName(self.enemyMsg.name);

        local force;
        local heroList;
        if self.enemyMsg.hero_list and #self.enemyMsg.hero_list >= self.lineupIdx then
            force = self.enemyMsg.hero_list[self.lineupIdx].force;
            heroList = self.enemyMsg.hero_list[self.lineupIdx].hero_list;
        else
            force = 0;
            heroList = {};
        end
        self.defenderItem:setForce(force);
        self:updateEnemyLineup(2, heroList);
    end
end

-- 九宫格数据更新
function Lua_FightLineupWindow:updateEnemyLineup(dataType, list)
    if self.enemyLineupPanel == nil then
        self.enemyLineupPanel = Lua_HeroGridViewPanel.new(self.content);
        self.enemyLineupPanel:setRectAnchor(1);
        self.enemyLineupPanel:setLocation(204, -209, 0);
        self.enemyLineupPanel:setCanClick(true);
        self.enemyLineupPanel:setLayout(1, 2);
        self.enemyLineupPanel:setGridCell(75, 75);
    end
    if dataType == 1 then -- 配置表数据
        self.defenderItem:setConfig(list, self.lineupIdx);
        self.enemyLineupPanel:setDataByConfig(list, self.lineupIdx);
    elseif dataType == 2 then -- 服务端数据
        self.defenderItem:setProto(list);
        self.enemyLineupPanel:setDataByProto(list);
    end
end

--一键上阵
function Lua_FightLineupWindow:onOneBtnClick(go)
    DataCenter.heroLineupData:setHeroOneKey(self.standType, self.lineupType, self.lineupIdx);

    self.data:initLineUpInfo();
    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
end

--开始战斗
function Lua_FightLineupWindow:onBtnFightClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.showLangValue(10031);
        return;
    end
    self.clickTime = getTime();

    local recordId = DataCenter.fightData:getRecordIdByTemplateId(self.template_id);
    if recordId > 0 then
        return;
    end

    if DataCenter.guideData.bPlayGuide then--引导中
        self:onFight();
    else
        self:onCheckArtifact();
    end
end

function Lua_FightLineupWindow:onFight()
    if self:checkIsChange() then
        self:onSaveLineup()
    end
    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
    self.onFightTime = getTime();
end