-- 光环图标
Lua_HeroLineupAureoleItem = class("Lua_HeroLineupAureoleItem", Lua_DisplayObject)
function Lua_HeroLineupAureoleItem:ctor(p, showType)
    self.showType = showType or 1;
    self:superCall("ctor", p, "HeroLineupAureoleItem_skin");
end

function Lua_HeroLineupAureoleItem:buildShowItem()
    self:superCall("buildShowItem");
    self.aureoleId = 0;

    self.forceNum = Lua_NumberImage.new(self.content);
    self.forceNum.preStr = "xui_zl1_number_0";
    self.forceNum.numOffsetX = -4;

    if self.showType == 2 then
        self.nameText.pivotValue = 5;
        self.nameText.alignmentValue = 5;
        self.nameText:setLocation(-45, 17, 0);
        self.forceIcon:setLocation(-66, -28, 0);
        self.forceNum:setLocation(-95, -28, 0);
        self.forceNum.pivot = -1;
    else
        self.nameText.pivotValue = 3;
        self.nameText.alignmentValue = 3;
        self.nameText:setLocation(45, 17, 0);
        self.forceIcon:setLocation(66, -28, 0);
        self.forceNum:setLocation(95, -28, 0);
        self.forceNum.pivot = 1;
    end

    self.icon:addClickFuntion(self, self.onAureoleClick);
end

function Lua_HeroLineupAureoleItem:dispose()
    if self.forceNum then
        self.forceNum:dispose();
        self.forceNum = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroLineupAureoleItem:setName(name)
    self.nameText.text = name;
end

function Lua_HeroLineupAureoleItem:setForce(force)
    if force and tonumber(force) > 0 then
        self.forceIcon:setEnable(true);
        self.forceNum:setEnable(true);
        self.forceNum.num = force;
    else
        self.forceIcon:setEnable(false);
        self.forceNum:setEnable(false);
    end
end

function Lua_HeroLineupAureoleItem:setLineup(lineupType, lineupIdx)
    local vo = DataCenter.heroLineupData:getLineupVo(lineupType);
    local arr = vo:getHeroArr(lineupIdx);
    local tab = DataCenter.heroLineupData:getAureoleInfo(lineupType, arr);
    local aureoleId = DataCenter.heroLineupUtil:getAureoleId(tab);
    self:setData(aureoleId);
end

function Lua_HeroLineupAureoleItem:setConfig(list, lineupIdx)
    local aureoleId = 0;
    list = list and list[lineupIdx] or nil;
    if list then
        local tab = {};
        local config;
        for i = 1, #list do
            config = Lua_MonsterConfigData.getMonsterConfig(list[i][1]);
            if tab[config.camp] == nil then
                tab[config.camp] = 1;
            else
                tab[config.camp] = tab[config.camp] + 1;
            end
        end
        aureoleId = DataCenter.heroLineupUtil:getAureoleId(tab);
    end
    self:setData(aureoleId);
end

function Lua_HeroLineupAureoleItem:setProto(list)
    local tab = DataCenter.heroLineupData:getAureoleInfoByProto(list);
    local aureoleId = DataCenter.heroLineupUtil:getAureoleId(tab);
    self:setData(aureoleId);
end

function Lua_HeroLineupAureoleItem:setData(aureoleId)
    self.aureoleId = aureoleId;
    local config = DataCenter.heroLineupUtil:getAureoleConfig(aureoleId);
    if config == nil then
        self.icon:setAltas("hero_embattle", "xui_bz_widget_24");
    else
        self.icon:setAltas(config.atlas, config.sprite);
    end
end

function Lua_HeroLineupAureoleItem:onAureoleClick(go)
	Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_OPEN, self.aureoleId);
end