--英雄布阵
checkRequire("Lua_BaseLineupWindow");
checkRequire("Lua_HeroLineupTabCell");
Lua_HeroLineupWindow = class("Lua_HeroLineupWindow", Lua_BaseLineupWindow)
function Lua_HeroLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_HeroLineupWindow";
    self.skinName = "HeroLineupWindow_skin";
    self.lineupType = 0;
end

function Lua_HeroLineupWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.connEffX_1 = 35
    self.connEffY_1 = -35
    self.connEffX_2 = -270
    self.connEffY_2 = -65

    self:addLuaEvent("UPDATE_HERO_LINEUP_INFO", self, self.onLineupInfoUpdate); -- 阵容保存
    self:addLuaEvent("LINEUP_OVERVIEW_COMPLETE", self, self.onOverviewed);

    self.aureoleIcon:addClickFuntion(self, self.checkAureole);
    self.btnSave:addClickFuntion(self, self.onBtnSaveClick);

    self.forceNum = Lua_NumberImage.new(self.bottomObject);
    self.forceNum:setLocation(0, 638, 0);
    self.forceNum.firstStr = "xui_zl1_number_10";
    self.forceNum.preStr = "xui_zl1_number_0";
    self.forceNum.numOffsetX = -2;
    self.forceNum.num = 0;
end

function Lua_HeroLineupWindow:dispose()
    if self.forceNum ~= nil then
        self.forceNum:dispose();
        self.forceNum = nil;
    end
    if self.buttonList then
        self.buttonList:dispose();
        self.buttonList = nil;
    end
    self.tabInfo = nil
    self:superCall("dispose");
end

function Lua_HeroLineupWindow:updateShowInfo(param)
    if type(param) == type_str_table then
        local arr;
        if param.typeof ~= nil and param:typeof() == "Array" then
            arr = param;
        else
            arr = Array();
            local vo;
            for i = 1, #param do
                vo = DataCenter.heroLineupData:getLineupVo(param[i]);
                arr:add(vo);
            end
        end
        if self.buttonList == nil then
            self.buttonList = Lua_ButtonList.new(self.bottomObject, Lua_AxisDefine.Horizontal);
            self.buttonList:setRectPivot(5);
            self.buttonList:setLocation(330, 540, 0);
            self.buttonList:setButtonCell(Lua_HeroLineupTabCell);
            self.buttonList:setButtonItem(165, 57);
            self.buttonList:setClickCallBack(self, self.onButtonClick);
        end
        self.buttonList:setData(arr);
        self.buttonList:setSelected(1);
    elseif type(param) == type_str_number then
        self.lineupType = param;
        self:showSceneByLineupType(self.lineupType);
        self:updateLineupInfo();
        self:createTeamButton(self.data.team_number);
        self.campSiftPanel:setSelected(self.defaultCamp, 0, true);
        if self.lineupType == 39 or self.lineupType == 41 or self.lineupType == 43 then
            self:showPrompt(true);
        else
            self:showPrompt(false);
        end
    end
end

function Lua_HeroLineupWindow:onButtonClick(index, data)
    if self.lineupType ~= 0 and self.lineupType ~= data.id then
        if self:checkIsChange() then
            self.switchLineupType = data.id;
            self:showTipsWindow();
            return
        end
    end
    self.lineupType = data.id;

    self:showSceneByLineupType(self.lineupType);
    self:updateLineupInfo();
    self:createTeamButton(self.data.team_number);
    self.campSiftPanel:setSelected(self.defaultCamp, 0, true);
end

function Lua_HeroLineupWindow:updateLineupNum()
    self.heroNum = self.data:getHeroNumByLineupIdx(self.lineupIdx)
end

-- 更新光环
function Lua_HeroLineupWindow:updateAureoleInfo()
    local num = DataCenter.heroLineupData:calcLineupForce(self.lineupType, self.lineupIdx);
    self.forceNum.num = num;

    local arr = self.data:getHeroArr(self.lineupIdx);
    local tab = DataCenter.heroLineupData:getAureoleInfo(self.lineupType, arr);
    self.aureoleId = DataCenter.heroLineupUtil:getAureoleId(tab);
    local config = DataCenter.heroLineupUtil:getAureoleConfig(self.aureoleId);
    if config == nil then
        self.aureoleIcon:setAltas("hero_embattle", "xui_bz_widget_24");
    else
        self.aureoleIcon:setAltas(config.atlas, config.sprite);
    end

    -- num = self.data:getConnectActivateNum(self.lineupIdx);
    -- self.aureoleIcon:setAltas("hero_embattle", "xui_bz_widget_"..(24 + num));
    -- self.connCount.text = num;
end

function Lua_HeroLineupWindow:onLineupInfoUpdate(lineupType)
    if self.data then
        self.data:initLocalInfo();
    end
    self:updateLineupInfo();
    self:updateHeroList();
end

function Lua_HeroLineupWindow:checkAureole(go)
    -- local num, arr = DataCenter.heroLineupData:getConnectArrByLineup(self.lineupType, self.lineupIdx)
    -- if arr == nil or arr:getSize() <= 0 then
    --     OperateAlert.showLangValue(126066)
    --     return
    -- end
    -- Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, arr)
    Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_OPEN, self.aureoleId);
end

-- 布阵改变提示
function Lua_HeroLineupWindow:showTipsWindow()
    local tipData = { des = 126306, posY = 30, btnType = 1, onFunType = 0, owner = self, cancelFun = self.onCancelFun, sureFun = self.onSureFun };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroLineupWindow:onCancelFun()
    if self.switchLineupType then -- 切换页签
        self.lineupType = self.switchLineupType
        self.switchLineupType = nil
        self:onLineupInfoUpdate();
    else
        if self:onBackClickCheck() then
            self:hide();
        end
    end
end

function Lua_HeroLineupWindow:onSureFun()
    if self:checkIsNull() then
        self:onLineupInfoUpdate();
        return;
    end

    self:onSaveLineup();
    if self.switchLineupType then -- 切换页签
        self.lineupType = self.switchLineupType
        self.switchLineupType = nil
        self:onLineupInfoUpdate();
    end

    if self.needCloseWin == true then
        if self:onBackClickCheck() then
            self:hide();
        end
    end
end

function Lua_HeroLineupWindow:onBackBtnClick(go)
    if self:checkIsChange() == true then
        self.needCloseWin = true;
        self:showTipsWindow();
    else
        if self:onBackClickCheck() then
            self:hide();
        end
    end
end

function Lua_HeroLineupWindow:checkIsNull()
    if self.lineupNum <= 1 then
        if self.heroNum == 0 and not self.data.isCanNil then
            OperateAlert.showLangValue(126307);
            return true;
        end
    else
        for i = 1, self.lineupNum do
            num = self.data:getHeroNumByLineupIdx(i)
            if num == 0 then
                OperateAlert.show(LanUtil.formateStr(126326, convert_arab_to_chinese(i)));
                return true;
            end
        end
    end
    return false;
end

-- 保存
function Lua_HeroLineupWindow:onBtnSaveClick()
    if self:checkIsNull() then
        return;
    end

    if self.heroNum < 2 then
        local arr = self.data:getHeroArr(self.lineupIdx);
        local heroVo;
        for i = 1, arr:getSize() do
            if arr[i] > 0 then
                heroVo = DataCenter.heroLineupData:getHeroVo(self.lineupType, arr[i]);
                if heroVo.trial_state then
                    OperateAlert.showLangValue(126330);
                    return;
                end
            end
        end
    end

    if not self:checkIsChange() then
        return;
    end

    if self.lineupType == 41 or self.lineupType == 43 then
        Lua_WindowUtil.openWin("Lua_LineupOverviewWindow", Lua_WinParam.ACTION_OPEN, self.lineupType);
    else
        self:onOverviewed();
    end
end

function Lua_HeroLineupWindow:onOverviewed(needCloseWin)
    self:onSaveLineup();
    if self.needCloseWin == true or needCloseWin then
        self:hide();
    end
end

function Lua_HeroLineupWindow:showPrompt(bValue)
    if bValue then
        if self.promptBg == nil then
            self.promptBg = UICreate.createUIAtlasImage(self.topObject, "hero_embattle", "xui_skzb_widget_23", 0, -126.5, 0, 0);
            self.promptText = UICreate.createLabel(self.topObject, nil, 0, -126.5, 100, 31, 24);
            self.promptText.pivotValue = 4;
            self.promptText.alignmentValue = 4;
            self.promptText.horizontalOverflowValue = 1;
            self.promptText.colorStr = Lua_ColorDefine.transColorStr("FBEBAB");
            self.promptText:setLangValue(126332);
        end
        self.promptBg:setEnable(true);
        self.promptText:setEnable(true);
    else
        if self.promptBg then
            self.promptBg:setEnable(false);
            self.promptText:setEnable(false);
        end
    end
end















-- 光环属性item
Lua_HeroAureoleAttrItem = class("Lua_HeroAureoleAttrItem", Lua_DisplayObject);
function Lua_HeroAureoleAttrItem:ctor(p)
    self:superCall("ctor", p, "HeroAureoleAttrItem_skin");
end

function Lua_HeroAureoleAttrItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroAureoleAttrItem:setData(attrVo)
    self.attr_value.text = LanUtil.formateStr(10049, tostring(attrVo.showValue));
    self.attr_value:resetSize();
    self.attr_icon:setAltas("common_altas_2", attrVo.attr_icon_1);
end

function Lua_HeroAureoleAttrItem.Get:itemW()
    return 35 + self.attr_value.width;
end

function Lua_HeroAureoleAttrItem:dispose()
    self:superCall("dispose");
end