checkRequire("Lua_FightLineupWindow");
checkRequire("Lua_ChaosCopyCondPanel");
Lua_ChaosCopyLineupWindow = class("Lua_ChaosCopyLineupWindow", Lua_FightLineupWindow)
function Lua_ChaosCopyLineupWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChaosCopyLineupWindow";
	self.template_id = Lua_FightDefine.TEMPLATE_ID_CHAOS_COPY;
	self.lineupType = Lua_HeroUtil.LINEUP_CHAOS_COPY;
	self.lineupIdx = 1;
end

function Lua_ChaosCopyLineupWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.condPanel = Lua_ChaosCopyCondPanel.new(self.topObject);
    self.condPanel:setRectAnchor(1);
    self.condPanel:setLocation(-325, -240.5, 0);
    self.condPanel:setShowHide(true);

	self.heroList:setListCell(Lua_ChaosCopyLineupHeroItem, 107, 107, 5);

	-- self:addLuaEvent("CHAOS_COPY_HERO_LIST", self, self.updateHeroList);
end

function Lua_ChaosCopyLineupWindow:dispose()
	if self.condPanel then
		self.condPanel:dispose();
		self.condPanel = nil;
	end
	if self.buttonList then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChaosCopyLineupWindow:updateShowInfo(param)
	self.stage_id = param;

	self.condPanel:setData(param);

	local config = DataCenter.chaosCopyUtil:getStageConfig(param);
	self.monster_player_id = config.monster;
	self:updateLineupInfo();
	self:showSceneByTemplateId(self.template_id);

	config = Lua_MonsterPlayerConfigData.getConfigData(self.monster_player_id);
	local len = #config.fighter_list;
	local teamNum = self.data.team_number;
	len = len > teamNum and teamNum or len;
	DataCenter.heroLineupData.lineupNum = len;
	if len > 1 then
		local arr = Array();
		for i = 1, len do
			arr:add({ textStr = LanUtil.formateStr(796027, tostring(i)); });
		end
		if self.buttonList == nil then
			self.buttonList = Lua_ButtonList.new(self.bottomObject, Lua_AxisDefine.Horizontal);
			self.buttonList:setRectPivot(5)
			self.buttonList:setLocation(359, 541, 0)
			self.buttonList:setButtonStyle("common_altas_3", "xui_common_toggle_003_b", "xui_common_toggle_003_f", 174, 57, 1, 1);
			self.buttonList:setButtonText(0, -5, "B2B0A6", "894E23", 28, 30, Lua_MyUISettings.huakangFontName);
			self.buttonList:setButtonItem(168, 54);
			self.buttonList:setClickCallBack(self, self.onButtonCick);
		end
		self.buttonList:setData(arr);
		self.buttonList:setSelected(1);
	else
		self:onButtonCick(1);
	end
end

function Lua_ChaosCopyLineupWindow:onButtonCick(index)
	self.lineupIdx = index;

	self:updateStandInfo();
	self:updateScenePosEff();
	self:updateSceneModel();
	self:updateArtifact();
	self:updateBeast();
	self:updateLineupNum();
	self:updateEnemyInfo();
	self.campSiftPanel:setSelected(self.defaultCamp, 0, true);
end

function Lua_ChaosCopyLineupWindow:updateHeroList()
    local arr = DataCenter.chaosCopyData:getHeroList(self.lineupType, self.selectedCampType, self.selectedCareer);
    self.heroList.customParam = self.lineupType * 10000 + self.lineupIdx;
    self.heroList:setArrayData(arr);
    self.heroList:moveToIndex(1, true);
    self:showNone(arr == nil or arr:getSize() <= 0);
end

function Lua_ChaosCopyLineupWindow:checkLineupIsFull(lineupIdx)
	local num = self.data:getHeroNumByLineupIdx(lineupIdx);
	local limitNum = self.data:getLineupLimitNum(lineupIdx);
	if num < limitNum and DataCenter.chaosCopyData:checkPackHaveHero(self.lineupType) then
		local tipsData = { des = 126312, btnType = 1, cancelLabel = 126328, owner = self, sureFun = self.onFight };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		return true;
	end
	return false;
end










Lua_ChaosCopyLineupHeroItem = class("Lua_ChaosCopyLineupHeroItem", Lua_HeroLineupCell)

function Lua_ChaosCopyLineupHeroItem:dispose()
	self:superCall("dispose");
end

function Lua_ChaosCopyLineupHeroItem:setData(data)
	self.data = DataCenter.chaosCopyData:getLineupHeroVo(data);
	self.itemIcon:setData(self.data);
	self:updateSelected();
end

function Lua_ChaosCopyLineupHeroItem:onLongPressClick()
    if Lua_WindowUtil.isWindowShowing("Lua_HeroTipsWindow") == false then
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, { heroVo = self.data, isShowBtn = false });
    end
end