-- 无尽关卡布阵
checkRequire("Lua_FightLineupWindow");
checkRequire("Lua_FightStarPanel");
Lua_EndlessLevelLineupWindow = class("Lua_EndlessLevelLineupWindow", Lua_FightLineupWindow);
function Lua_EndlessLevelLineupWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_EndlessLevelLineupWindow";
end

function Lua_EndlessLevelLineupWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.condBg = UICreate.createUIAtlasImage(self.topObject, "endless_level_atlas", "xui_dbzl_widget_1", -360, -130, 0, 0);
	self.condBg.pivotValue = 3;
	self.condTxt = UICreate.createLabel(self.topObject, nil, -340, -130, 100, 30, 22);
	self.condTxt.pivotValue = 3;
	self.condTxt.alignmentValue = 3;
	self.condTxt.horizontalOverflowValue = 1;
	self.condTxt.verticalOverflowValue = 1;

	self.defenderItem:setForce(0);
	self:addLuaEvent("UPDATE_ENDLESSLEVEL_INFO", self, self.updateStarCond);
end

function Lua_EndlessLevelLineupWindow:updateShowInfo(param)
	self:superCall("updateShowInfo", param);
	self:updateStarCond();
end

-- 选择英雄
function Lua_EndlessLevelLineupWindow:onHeroSelected(heroVo)
	self:superCall("onHeroSelected", heroVo);
	self:updateStarCond();
end

function Lua_EndlessLevelLineupWindow:onHeroCampPosChange(uid)
	self:superCall("onHeroCampPosChange", uid);
	self:updateStarCond();
end

function Lua_EndlessLevelLineupWindow:updateStarCond()
	local campCareerDic, campDic, careerDic, num = self:calcData();
	local arr = DataCenter.endlessLevelData.starCondArr;
	local len = arr:getSize();
	local challengeCond = DataCenter.endlessLevelData.challengeCond;
	local str = "";
	for i = 1, len do
		arr[i]:init();
		arr[i]:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
		arr[i]:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);

		local camp, career, target, campName, careerName;
		local colorStr, hasCampCareer, campCareerMinus, hasCampNum, campMinus, hasCareerNum, careerMinus;
		if #challengeCond[i][2] > 2 then -- 满足阵营和职业
			camp = challengeCond[i][2][1];
			career = challengeCond[i][2][2];
			target = challengeCond[i][2][3];
			campName = DataCenter.heroUtil:getCampName(camp);
			careerName = DataCenter.heroUtil:getHeroCareer(career);
			if camp > 0 and career > 0 then -- 阵营职业
				hasCampCareer = 0;
				if campCareerDic[camp] ~= nil then
					hasCampCareer = campCareerDic[camp][career] or 0;
				end
				campCareerMinus = target - hasCampCareer;
				colorStr = "FFFFFF";
				if challengeCond[i][1] == 4 and campCareerMinus > 0 then
					colorStr = "ED4C30";
				elseif challengeCond[i][1] == 5 and campCareerMinus < 0 then
					colorStr = "ED4C30";
				end
				str = str .. LanUtil.formateStr(779064, target, campName, careerName, colorStr, hasCampCareer, target);
			elseif camp > 0 then -- 阵营
				hasCampNum = campDic[camp] or 0;
				campMinus = target - hasCampNum;
				colorStr = "FFFFFF";
				if challengeCond[i][1] == 4 and campMinus > 0 then
					colorStr = "ED4C30";
				elseif challengeCond[i][1] == 5 and campMinus < 0 then
					colorStr = "ED4C30";
				end
				str = str .. LanUtil.formateStr(779065, target, campName, colorStr, hasCampNum, target);
			elseif career > 0 then -- 职业
				hasCareerNum = careerDic[career] or 0;
				careerMinus = target - hasCareerNum;
				colorStr = "FFFFFF";
				if challengeCond[i][1] == 4 and careerMinus > 0 then
					colorStr = "ED4C30";
				elseif challengeCond[i][1] == 5 and careerMinus < 0 then
					colorStr = "ED4C30";
				end
				str = str .. LanUtil.formateStr(779065, target, careerName, colorStr, hasCareerNum, target);
			end
			if challengeCond[i][1] == 4 then
				str = LanUtil.getValue(779067) .. str;
			elseif challengeCond[i][1] == 5 then
				str = LanUtil.getValue(779068) .. str;
			end
			if i ~= len then
				str = str .. "\n";
			end
		end
	end
	self.condTxt.text = str;
	self.condTxt:resetSize();
	self.condBg:SetDimensions(self.condBg.width, self.condTxt.height + 14);
end

function Lua_EndlessLevelLineupWindow:calcData()
	local vo;
	local campCareerDic = {};
	local campDic = {};
	local careerDic = {};
	local num = 0;
	local arr = self.heroDic[self.lineupIdx]
	for i = 1, arr:getSize() do
		if arr[i] > 0 then
			vo = DataCenter.heroData:getItemByUniqueId(arr[i]);
			if campCareerDic[vo.campType] == nil then
				campCareerDic[vo.campType] = {};
			end
			if campCareerDic[vo.campType][vo.career] == nil then
				campCareerDic[vo.campType][vo.career] = 1;
			else
				campCareerDic[vo.campType][vo.career] = campCareerDic[vo.campType][vo.career] + 1;
			end

			if campDic[vo.campType] == nil then
				campDic[vo.campType] = 1;
			else
				campDic[vo.campType] = campDic[vo.campType] + 1;
			end

			if careerDic[vo.career] == nil then
				careerDic[vo.career] = 1;
			else
				careerDic[vo.career] = careerDic[vo.career] + 1;
			end
			num = num + 1;
		end
	end
	return campCareerDic, campDic, careerDic, num;
end

-- 一键上阵（复制星河殿逻辑）
function Lua_EndlessLevelLineupWindow:onOneBtnClick(go)
	-- local value = DataCenter.starTrialUitl:getConstConfig("line_up_one_key", "value");
	-- value = value == nil and 0 or value;
	-- local curChapter = DataCenter.starTrialData.curChapter;
	-- if curChapter - 1 < value then
	-- 	OperateAlert.show(LanUtil.formateStr(201628, tostring(value)));
	-- 	return;
	-- end

	local arr = DataCenter.heroLineupData:getHeroList(0, 0, self.lineupType, self.lineupIdx, 1);
	local len = arr:getSize();
	if len <= 0 then
		return;
	end

	local list = DataCenter.heroLineupUtil:getStandListByType(self.standType);
	local need_num = #list;
	local standArr = self.heroDic[self.lineupIdx]
	for i = 1, standArr:getSize() do -- 一键上阵，需要卸下当前所有英雄再重新上阵
		standArr[i] = 0
	end

	local campCareerDic, campDic, careerDic, num = self:calcData();
	local arr = DataCenter.endlessLevelData.starCondArr;
	local starVo = arr[1];
	starVo:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
	starVo:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);

	local existCamp = {};
	local existCareer = {};
	function setCampCareer(condVo)
		if condVo and condVo.bMeet and (condVo.condType == 4 or condVo.condType == 5 or condVo.condType == 7) then
			if condVo.value1 == 0 then
				if condVo.value2 > 0 then
					existCareer[condVo.value2] = 1;
				end
			else
				existCamp[condVo.value1] = 1;
				if condVo.value2 > 0 then
					existCareer[condVo.value2] = 1;
				end
			end
		end
	end

	local condArr = starVo.condArr
	for i = 1, condArr:getSize() do
		setCampCareer(condArr[i])
	end

	local existDic = {};
	local heroArr = Array();
	function setHeroLineup(standIdx, heroVo, condVo)
		standArr[standIdx] = heroVo.unique_id;
		existDic[heroVo.id] = standIdx;
		need_num = need_num - 1;
		campCareerDic, campDic, careerDic, num = self:calcData();
		starVo:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
		starVo:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);
		setCampCareer(condVo)
		heroArr:add(heroVo.unique_id)
	end

	local standIdx;
	local heroVo;
	local condVo;
	for i = 1, #list do
		standIdx = list[i];
		if standArr[standIdx] == 0 then
			condVo = starVo:getUnMeetVo();
			if condVo == nil then
				for j = 1, len do
					heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
					if existDic[heroVo.id] == nil and existCamp[heroVo.campType] == nil and existCareer[heroVo.career] == nil then
						setHeroLineup(standIdx, heroVo);
						break;
					end
				end
			else
				for j = 1, len do
					heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
					if existDic[heroVo.id] == nil then
						if condVo.value1 == 0 then
							if condVo.value2 == 0 then
								setHeroLineup(standIdx, heroVo, condVo);
								break;
							else
								if heroVo.career == condVo.value2 then
									setHeroLineup(standIdx, heroVo, condVo);
									break;
								end
							end
						else
							if condVo.value2 == 0 then
								if heroVo.campType == condVo.value1 then
									setHeroLineup(standIdx, heroVo, condVo);
									break;
								end
							else
								if heroVo.campType == condVo.value1 and heroVo.career == condVo.value2 then
									setHeroLineup(standIdx, heroVo, condVo);
									break;
								end
							end
						end
					end
				end
			end
		end
	end

	-- if need_num > 0 and not starVo.isMeet then
	if need_num > 0 then
		for i = 1, #list do
			standIdx = list[i];
			if standArr[standIdx] == 0 then
				for j = 1, len do
					heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
					if existDic[heroVo.id] == nil then
						setHeroLineup(standIdx, heroVo);
						break;
					end
				end
			end
			if need_num == 0 then
				break;
			end
		end
	end

	if not starVo.isMeet then -- 策划需求：不满足则无视条件，所以上面的计算都是浪费的
		for i = 1, standArr:getSize() do
			standArr[i] = 0
		end

		table.clear(existDic)
		for i = 1, #list do
			standIdx = list[i];
			if standArr[standIdx] == 0 then
				for j = 1, len do
					heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
					if existDic[heroVo.id] == nil then
						setHeroLineup(standIdx, heroVo);
						break;
					end
				end
			end
			if need_num == 0 then
				break;
			end
		end
	end
	-- 按战斗系统站位上阵
	DataCenter.heroLineupData:heroListSortByForce(heroArr);
	DataCenter.heroLineupData:setHeroOneKey(self.standType, self.lineupType, self.lineupIdx, heroArr);

	self.data:initLineUpInfo();
	self:updateHeroSelected();
	self:updateSceneModel();
	self:updateLineupNum();
	self:updateAureoleInfo();
	self:updateStarCond();
end

function Lua_EndlessLevelLineupWindow:onCheckArtifact()
	local actVo = DataCenter.backstageActData:getActVoByIdx(self.stage_id);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		self:hide();
		return;
	elseif actVo.residueTime <= Lua_EndlessLevelData.reusltRankTime then -- 最后一天30分用于计算排名数据
		OperateAlert.showLangValue(779016);
		return;
	end

	local campCareerDic, campDic, careerDic, num = self:calcData();
	local arr = DataCenter.endlessLevelData.starCondArr;
	local challengeCond = DataCenter.endlessLevelData.challengeCond;
	local len = arr:getSize();
	local str = "";
	for i = 1, len do
		arr[i]:init();
		arr[i]:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
		arr[i]:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);
		if not arr[i].isMeet then
			local camp, career, target, campName, careerName;
			local hasCampCareer, campCareerMinus, hasCampNum, campMinus, hasCareerNum, careerMinus;
			if #challengeCond[i][2] > 2 then -- 满足阵营和职业
				camp = challengeCond[i][2][1];
				career = challengeCond[i][2][2];
				target = challengeCond[i][2][3];
				campName = DataCenter.heroUtil:getCampName(camp);
				careerName = DataCenter.heroUtil:getHeroCareer(career);
				if camp > 0 and career > 0 then -- 阵营职业
					hasCampCareer = 0;
					if campCareerDic[camp] ~= nil then
						hasCampCareer = campCareerDic[camp][career] or 0;
					end
					campCareerMinus = target - hasCampCareer;
					if campCareerMinus > 0 then
						str = str .. LanUtil.formateStr(779053, campCareerMinus, campName, careerName);
					elseif campCareerMinus < 0 then
						str = str .. LanUtil.formateStr(779054, -campCareerMinus, campName, careerName);
					end
				elseif camp > 0 then -- 阵营
					hasCampNum = campDic[camp] or 0;
					campMinus = target - hasCampNum;
					if campMinus > 0 then
						str = str .. LanUtil.formateStr(779055, campMinus, campName);
					elseif campMinus < 0 then
						str = str .. LanUtil.formateStr(779056, -campMinus, campName);
					end
				elseif career > 0 then -- 职业
					hasCareerNum = careerDic[career] or 0;
					careerMinus = target - hasCareerNum;
					if careerMinus > 0 then
						str = str .. LanUtil.formateStr(779055, careerMinus, careerName);
					elseif careerMinus < 0 then
						str = str .. LanUtil.formateStr(779056, -careerMinus, careerName);
					end
				end
			end
		end
	end
	if #str > 0 then
		OperateAlert.show(LanUtil.formateStr(779057, str));
		return;
	end
	self:superCall("onCheckArtifact");
end

function Lua_EndlessLevelLineupWindow:onFight()
	if self:checkIsChange() then
		self:onSaveLineup();
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
	DataCenter.endlessLevelData.isNeedRefresh = true;
end

function Lua_EndlessLevelLineupWindow:dispose()
	if self.condBg then
		self.condBg:dispose()
		self.condBg = nil
	end
	if self.condTxt then
		self.condTxt:dispose()
		self.condTxt = nil
	end
	self:superCall("dispose")
end