-- 星魂试炼 战斗布阵Window
checkRequire("Lua_FightLineupWindow");
checkRequire("Lua_FightStarPanel")
Lua_StarTrialLineupWindow = class("Lua_StarTrialLineupWindow", Lua_FightLineupWindow);
function Lua_StarTrialLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_StarTrialLineupWindow";
end

function Lua_StarTrialLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    local value = DataCenter.starTrialUitl:getConstConfig("line_up_one_key", "value")
    value = value == nil and 0 or value
    local curChapter = DataCenter.starTrialData.curChapter
    if curChapter - 1 < value then
        self.stand_bg:setLocation(302, 54.5, 0)
        self.stand_btn:setLocation(302, 54.5, 0)
        self.stand_name:setLocation(302, 17.5, 0)
        self.one_btn:setEnable(false)
    else
        self.stand_bg:setLocation(302, 570, 0)
        self.stand_btn:setLocation(302, 570, 0)
        self.stand_name:setLocation(302, 533, 0)
        self.one_btn:setEnable(true)
    end

    self.starPanel = Lua_FightStarPanel.new(self.topObject)
    self.starPanel:setRectAnchor(1)
    self.starPanel:setLocation(-325, -240.5, 0)
    self.starPanel:setShowHide(true)
end

function Lua_StarTrialLineupWindow:dispose()
    if self.starPanel then
        self.starPanel:dispose()
        self.starPanel = nil
    end
    self:superCall("dispose")
end

function Lua_StarTrialLineupWindow:updateShowInfo(param)
    self:superCall("updateShowInfo", param);
    self:updateStarCond();
end

--选择英雄
function Lua_StarTrialLineupWindow:onHeroSelected(heroVo)
    self:superCall("onHeroSelected", heroVo);
    self:updateStarCond();
end

function Lua_StarTrialLineupWindow:onHeroCampPosChange(uid)
    self:superCall("onHeroCampPosChange", uid);
    self:updateStarCond();
end

function Lua_StarTrialLineupWindow:updateStarCond()
    local heroArr = self.heroDic[self.lineupIdx];
    local stageVo = DataCenter.starTrialUitl:getStageVo(self.stage_id);
    local arr = stageVo.starCondArr;
    local len = arr:getSize();
    for i = 1, len do
        arr[i]:init();
        arr[i]:checkCampAndCareer(heroArr);
    end
    self.starPanel:setData(nil, arr)
end

-- 一键上阵
function Lua_StarTrialLineupWindow:onOneBtnClick(go)
    -- local value = DataCenter.starTrialUitl:getConstConfig("line_up_one_key", "value");
    -- value = value == nil and 0 or value;
    -- local curChapter = DataCenter.starTrialData.curChapter;
    -- if curChapter - 1 < value then
    --     OperateAlert.show(LanUtil.formateStr(201628, tostring(value)));
    --     return;
    -- end

    local arr = DataCenter.heroLineupData:getHeroList(0, 0, self.lineupType, self.lineupIdx, 1);
    local len = arr:getSize();
    if len <= 0 then
        return;
    end

    local list = DataCenter.heroLineupUtil:getStandListByType(self.standType);
    local need_num = #list;
      
    local resultArr = Array();
    local existDic = {};
    local stageVo = DataCenter.starTrialUitl:getStageVo(self.stage_id);
    local starVo = stageVo.starCondArr[2];
    starVo:checkCampAndCareer(resultArr);
    
    local heroVo;
    for i = 1, len do
        heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
        if existDic[heroVo.id] == nil then
            if starVo.isMeet then
                break;
            else
                condVo = starVo:getUnMeetVo();
                if condVo.value1 == 0 then
                    if condVo.value2 == 0 then
                        resultArr:add(heroVo.unique_id);
                        existDic[heroVo.id] = 1;
                        need_num = need_num - 1;
                        starVo:checkCampAndCareer(resultArr);
                    else
                        if heroVo.career == condVo.value2 then
                            resultArr:add(heroVo.unique_id);
                            existDic[heroVo.id] = 1;
                            need_num = need_num - 1;
                            starVo:checkCampAndCareer(resultArr);
                        end
                    end
                else
                    if condVo.value2 == 0 then
                        if heroVo.campType == condVo.value1 then
                            resultArr:add(heroVo.unique_id);
                            existDic[heroVo.id] = 1;
                            need_num = need_num - 1;
                            starVo:checkCampAndCareer(resultArr);
                        end
                    else
                        if heroVo.campType == condVo.value1 and heroVo.career == condVo.value2 then
                            resultArr:add(heroVo.unique_id);
                            existDic[heroVo.id] = 1;
                            need_num = need_num - 1;
                            starVo:checkCampAndCareer(resultArr);
                        end
                    end
                end
            end
        end
    end
    for i = 1, len do
        if need_num <= 0 then
            break;
        end

        heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
        if existDic[heroVo.id] == nil then
            starVo:checkCampAndCareer(resultArr, heroVo);
            if starVo.isMeet then
                resultArr:add(heroVo.unique_id);
                existDic[heroVo.id] = 1;
                need_num = need_num - 1;
            end
        end
    end

    -- 按战斗系统站位上阵
    DataCenter.heroLineupData:setLineupOneKey(self.standType, self.lineupType, self.lineupIdx, resultArr);

    self.data:initLineUpInfo();
    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
    self:updateStarCond();
end