checkRequire("Lua_FightLineupWindow");
Lua_TimeSpaceRaceLineupWindow = class("Lua_TimeSpaceRaceLineupWindow", Lua_FightLineupWindow)
function Lua_TimeSpaceRaceLineupWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_TimeSpaceRaceLineupWindow";
end

function Lua_TimeSpaceRaceLineupWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATE_OTHER_ROLE_LINEUP", self, self.updateRoleLineup);
	self:addLuaEvent("TIME_SPACE_FIGHT_CHECK", self, self.onFightCheck);
	self:addLuaEvent("TIME_SPACE_FIGHT_CHECK_ERROR", self, self.onFightCheckError);

	self.promptBg = UICreate.createUIAtlasImage(self.bottomObject, "hero_embattle", "xui_skzb_widget_23", 0, 615, 0, 0);

	self.promptText = UICreate.createLabel(self.bottomObject, nil, 0, 615, 100, 31, 24);
	self.promptText.pivotValue = 4;
	self.promptText.alignmentValue = 4;
	self.promptText.horizontalOverflowValue = 1;
	self.promptText.colorStr = Lua_ColorDefine.transColorStr("FBEBAB");
	self.promptText:setLangValue(126332);
end

function Lua_TimeSpaceRaceLineupWindow:updateShowInfo(param)
	self.lineupType = param.attackLineup;
	self:showSceneByLineupType(self.lineupType);
	self:updateLineupInfo();
	self:createTeamButton(self.data.team_number);
	self.campSiftPanel:setSelected(self.defaultCamp, 0, true);

	local info = DataCenter.timeSpaceRaceData:getEnemyInfo(param.playerId);
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleLineup(param.playerId, info.show_role.server_flag, param.defendLineup, 1);
end

function Lua_TimeSpaceRaceLineupWindow:updateRoleLineup(msg)
	self.enemyMsg = msg;
	self:updateEnemyInfo();
end

function Lua_TimeSpaceRaceLineupWindow:onFight()
	Lua_ProxyManager.getProxy("Lua_TimeSpaceRaceProxy"):sFightCheck(self.showData.playerId, 2);
end

function Lua_TimeSpaceRaceLineupWindow:onFightCheck(value)
	if value == 2 then
		if self:checkIsChange() then
			self:onSaveLineup();
		end
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(Lua_FightDefine.TEMPLATE_ID_TIME_SPACE_RACE, 0, self.showData.playerId);
		self.onFightTime = getTime();	
	end
end

function Lua_TimeSpaceRaceLineupWindow:onFightCheckError()
	local tipsData = { des = 770033, sureLabel = 770034, btnType = 4, owner = self, sureFun = self.hide };
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end