checkRequire("Lua_HeroLineupWindow");
checkRequire("Lua_WildLodeLineupCell");
Lua_WildLodeDefendLineupWindow = class("Lua_WildLodeDefendLineupWindow", Lua_HeroLineupWindow)
function Lua_WildLodeDefendLineupWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_WildLodeDefendLineupWindow";
end

function Lua_WildLodeDefendLineupWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.heroList:setListCell(Lua_WildLodeLineupCell, 107, 107, 5);
end

function Lua_WildLodeDefendLineupWindow:updateShowInfo(param)
	self.lineupType = param.lineup_type;
	self.stageId = param.stage_id;
    self:showSceneByLineupType(self.lineupType);
    self:updateLineupInfo();
    self:createTeamButton(param.team_num);	
    self.campSiftPanel:setSelected(self.defaultCamp, 0);
end

function Lua_WildLodeDefendLineupWindow:showSceneByLineupType(lineupType)
	if lineupType == nil then
		return;
	end

	if self.sceneDic == nil then
		self.sceneDic = {};
	end
	local sceneId = DataCenter.wildSecretData:getLodeFightSceneId(self.stageId);
	if sceneId == nil then
		sceneId = DataCenter.heroLineupData:getLineUpSceneId(lineupType);
	end
	self.sceneDic[sceneId] = 1;
	self:setWinSceneId(sceneId);
end

function Lua_WildLodeDefendLineupWindow:onSaveLineup(lineupType)
	lineupType = lineupType or self.lineupType
	local num = lineupType - 48;
	local id = DataCenter.wildSecretData:getSelfLodeIdByNum(num);
	if id == 0 then
		OperateAlert.showLangValue(701085);
		self:hide();
		return;
	end
	self:superCall("onSaveLineup", lineupType);
end